'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Clipboard = function (_Component) {
  _inherits(Clipboard, _Component);

  function Clipboard() {
    _classCallCheck(this, Clipboard);

    return _possibleConstructorReturn(this, (Clipboard.__proto__ || Object.getPrototypeOf(Clipboard)).apply(this, arguments));
  }

  _createClass(Clipboard, [{
    key: '_copyToClipboard',
    value: function _copyToClipboard() {
      return document.execCommand('copy');
    }
  }, {
    key: 'copy',
    value: function copy(text) {
      var isRTL = document.documentElement.getAttribute('dir') == 'rtl';

      var fakeElem = document.createElement('textarea');
      // Prevent zooming on iOS
      fakeElem.style.fontSize = '12pt';
      // Reset box model
      fakeElem.style.border = '0';
      fakeElem.style.padding = '0';
      fakeElem.style.margin = '0';
      // Move element out of screen horizontally
      fakeElem.style.position = 'absolute';
      fakeElem.style[isRTL ? 'right' : 'left'] = '-9999px';
      // Move element to the same position vertically
      var yPosition = window.pageYOffset || document.documentElement.scrollTop;
      fakeElem.style.top = yPosition + 'px';

      fakeElem.setAttribute('readonly', '');
      fakeElem.value = text;

      document.body.appendChild(fakeElem);

      fakeElem.select();

      var succeeded = void 0,
          error = void 0;

      try {
        succeeded = this._copyToClipboard();
      } catch (err) {
        succeeded = false;
        error = err;
      }

      document.body.removeChild(fakeElem);

      this.handleResult(succeeded, error);
    }
  }, {
    key: 'handleResult',
    value: function handleResult(succeeded, error) {
      if (succeeded) {
        this.props.onSuccess && this.props.onSuccess();
      } else {
        this.props.onError && this.props.onError(error);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          render = _props.render,
          text = _props.text,
          props = _props.props;

      return render(_extends({}, props, { copy: function copy() {
          return _this2.copy(text);
        } }));
    }
  }]);

  return Clipboard;
}(_react.Component);

Clipboard.propTypes = {
  render: _propTypes2.default.func.isRequired,
  text: _propTypes2.default.string.isRequired,
  props: _propTypes2.default.object,
  onSuccess: _propTypes2.default.func,
  onError: _propTypes2.default.func
};

exports.default = Clipboard;